﻿# Saml2 Certificate Export and encoding 
function GetRandomChar()
{
    $supportedChars = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz1234567890!@#$%^&*()"
    $randomIndex = Get-Random -Maximum $supportedChars.Length
    return $supportedChars[$randomIndex]
}

#
# Output the configuration for SAML2 in ArgoCd
# usage : exportCertificateForArgo "current" cert:\localmachine\My\E05B32EA03A35C574AD29561CE487AA7D1A00706;
#
function exportCertificateForArgo($certType, $certificatePath){

    if ($certificatePath -eq $null)
    {
        return
    }
    $certificateExportPassword = ( 0..10 | % {GetRandomChar} ) -join "";
    $secureCertificateExportPassword = ConvertTo-SecureString -String $certificateExportPassword -Force -AsPlainText
    $temp_cert_file = ".\\${certType}cert_temp_output.pfx";
    $outputFile = Export-PfxCertificate -Cert $certificatePath -FilePath $temp_cert_file -Password $secureCertificateExportPassword ;
    $base64CertificateEncoding = [Convert]::ToBase64String([IO.File]::ReadAllBytes($outputFile.FullName));
    $passwordBytes = [System.Text.Encoding]::ASCII.GetBytes($certificateExportPassword)
    $base64PassowrdText =[Convert]::ToBase64String($passwordBytes)
    echo "global.userInputs.certificate.identity.saml.${certType}ServiceCert -> $base64CertificateEncoding" 
    echo "global.userInputs.certificate.identity.saml.${certType}ServiceCertPassword  -> $base64PassowrdText" 
}

echo "Update ArgoCD configuration with following parameters :"
exportCertificateForArgo "current" __CURRENT_CERTIFICATE_PATH__
exportCertificateForArgo "future" __FUTURE_CERTICICATE_PATH__

